﻿using System;
using System.Windows.Forms;
using LibUsbDotNet;
using LibUsbDotNet.Main;

namespace Windows_Form_USB_App
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {

            byte[] readBuffer = new byte[64];
            byte[] WriteBuffer = new byte[64];

            UsbDeviceFinder DeviceFinder = new UsbDeviceFinder(0x16C0, 0x05DC);
            UsbDevice Device = UsbDevice.OpenUsbDevice(DeviceFinder);

            if (Device == null)
            {
                button1.Text = "Device Not Found.";
                return;
            }

            IUsbDevice wholeUsbDevice = Device as IUsbDevice;
            if (!ReferenceEquals(wholeUsbDevice, null))
            {
                wholeUsbDevice.SetConfiguration(1);
                wholeUsbDevice.ClaimInterface(0);
            }

            UsbEndpointWriter Writer = Device.OpenEndpointWriter(WriteEndpointID.Ep01);
            UsbEndpointReader Reader = Device.OpenEndpointReader(ReadEndpointID.Ep01,64);

            Reader.DataReceived += Reader_DataReceived;
            Reader.DataReceivedEnabled = true;

            if (Device != null)
                button1.Text = "Device Found.";

        }

        private void Reader_DataReceived(object sender, EndpointDataEventArgs e)
        {

            this.Invoke((MethodInvoker)delegate()
            {
                textBox1.Text = System.Text.Encoding.Default.GetString(e.Buffer);
            });

        }

    }

}
